% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Curvas de remanso / backwater calculation
% Licencia GPLv3 https://www.gnu.org/licenses/gpl-3.0.txt
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Output / Salidas
% x_calc, y_calc (depth/calado), elevation
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% To do: 1 change global variable qast by arguments and use of @ functions
% and perhaps variable input argument
% 2 different sections
% 3 irregular sections
% 4 dq/dx < 0 
% 5 change of sections?
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% definicion de parametros globales y constantes
g=9.81;
%
global qast;% Definicion qast (dQ/dx)
%global canal;

%% CARGAMOS LOS DATOS DEL SCRIPT 
%% INCLUIDAS LAS VARIABLES DE CONTROL SOBRE SI LOS DATOS SE COGEN DE DICHO FICHERO O NO
datos_para_script_calculo_remanso

  if ~parametros_definidos_aqui,
  Q0 = Q_ext
%  y0 = y2comp;
  y0c = yc
  y0n = yn
%  x0 = 0%L0 (es el 0)
  xend = Lend;% xend = +10; calcula perfil hasta 10 m aguas abajo (- aguas arriba)
  Is=Is_ext
%Is = 0.0002; % pendiente (sin inclinacion)
  %
  resuelve_ode = 1; %1 RK ode, 2 metodo directo con deltay
%  deltay=0; % solo necesario si resuelve_ode==2

%%%%%%%%%%%%%%%%%%%%%%%
% Definicion seccion
%%%%%%%%%%%%%%%%%%%%%%%

  canal.tipo = tipodecanal;
% 1 rectangular, 2 trapezoidal, 3 trapezoidal k1k2 
% 4 triangular, 5 parabolica, 6 circular, 7 herradura, 
% 100 definido mediante tablas (sin implementar)
% 110 compuesto
% 1, 2 y 3 se pueden definir conjuntamente pero más eficiente 
% por separado
  canal.param = parametroscanal;
% canal.param = [b]; % 1
% canal.param = [b k];%2
% canal.param = [b k1 k2];%3
% canal.param = [k];%4
%
%
  canal.alfa = 1; %metido aqui por si acaso forma no regular 
  canal.beta = 1; %metido aqui por si acaso forma no regular
  if exist('beta_ext')
    canal.alfa = alpha_ext;
    canal.beta =  beta_ext;
  endif
%
%
  canal.n = n%0.013 % Coeficiente manning (G-M-S)

  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % Flujo Espacialmente Variado??
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % POR AHORA SIN LEER EXTERNAMENTE!!!
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  if ~exist('qast_ext')
    qast.tipo = 0;%
%%% tipos
% 0 Q cte
% 1 Q creciente con dQ/dx cte
% -1 Q decreciente con dQ/dx siguiendo modelo X (sin implementar)
    qast.value = 0; %% solo se lee si qast.tipo==1 (en ese caso qast.value es qast, i.e. dQ/dx)
    qast.U = 0; %despreciamos el termino eq a delta 90 grados
    qast.delta = 90; %grados
    %%%%
    %%%%
else
    qast.tipo = qast_ext;
    qast.value = qast_value_ext;
    qast.U = qast_U_ext; 
    qast.delta = qast_delta_ext; %grados
  
endif
end
%%
%%%

% Metemos todo lo que necesita f(x,y) en estructura canal
costitas = cos(asin(Is));
%
canal.costitas=costitas;
canal.Is = Is;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Definicion funciones A(y), T(y), R(y), Fr^2(y,Q), Ie(y,Q)
define_A_T_R_seccion
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%
% coef. qast %
switch qast.tipo
  case 0
    qast.cdist = 1;

    
  case 1
    qast.cdist = canal.beta/canal.alfa;
  case -1
% sin implementar
    qast.cdist = 1;    

endswitch
%%%%%%%%%%%%



if qast.tipo==0,
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %% Calcular ¡¡yn y/o yc(x)!!!
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Q cte
  function err=error(y,Q0,canal)
    err = 1 - Fr2(y,Q0,canal);
  endfunction
  yc = fzero(@(y) error(y,Q0,canal),y0c);
  
  function err=error2(y,Q0,canal)
    Is=canal.Is;
    err = Is - Ie(y,Q0,canal);
  endfunction
  if Is>0,  % canales H o  A no yn
    yn = fzero(@(y) error2(y,Q0,canal),y0n);
    %%%%%%%%%%%%%%%%%%%%%%%%%%
  else
    yn = inf;
  end
endif



if resuelve_ode==1,
  ode_opciones = odeset("RelTol",1e-4,"AbsTol",1e-4,"InitialStep",0.01,"MaxStep",1,"OutputFcn", @odeprint);
  ode_opciones_rapido = odeset("RelTol",1e-2,"AbsTol",1e-2,"InitialStep",0.1,"MaxStep",0.5,"OutputFcn", @odeprint);
  [x_calc,y_calc] = ode45(@(x,y) dydx(x,y,canal,Q0),[0 xend], [y0],ode_opciones);
elseif resuelve_ode==2,
% metodo directo:
  n_paso=1;
  x_calc(n_paso)= 0;
  y_calc(n_paso) = y0;
  Ei = y_calc(n_paso) +Q0^2/canal.area(y_calc(n_paso))^2/2/g;
  Iei = Ie(y_calc(n_paso),Q0,canal);
  while abs(x_calc(n_paso)) < abs(xend),
    n_paso= n_paso+1;
    y_calc(n_paso) = y_calc(n_paso-1) + deltay;
    
    E0=Ei;
    Ai=canal.area(y_calc(n_paso));Ri=canal.Rh(y_calc(n_paso));
    Ei = y_calc(n_paso)+Q0^2/Ai^2/2/g; 
    Ie0=Iei;
    Iei =Ie(y_calc(n_paso),Q0,canal);
    Iem = (Ie0 + Iei)/2;
    inc_x = (Ei-E0)/(Is - Iem);
    x_calc(n_paso)=x_calc(n_paso-1)+inc_x;
  endwhile
elseif resuelve_ode == 3,
%  deltaxode3
  x_calc = 0; y_calc=y0; deltax=deltaxode3;
  ndata=1;
  for x=deltax:deltax:xend,
    
    error = 1;
    xant = x_calc(ndata);
    yant= y_calc(ndata);
%
    Q = Q0+qast.value .* x;
    Qant = Q0+qast.value .*xant;
    Qm =0.5*(Q+Qant);
    deltaQ=Q-Qant;
    Vant = Qant/canal.area(yant);
%
    ynext0 = Is*deltax + yant;

    while error > 1e-4,
%%% calculo deltay' : deltayelevacion
      Vnew = Q/canal.area(ynext0);
      Vm = 0.5*(Vnew+Vant);
      deltaV = Vnew-Vant;
      Iem = 0.5*(Ie(yant,Qant,canal)+Ie(ynext0,Q,canal));
      if expresionendiffinitas==1,
        deltayelevacion = canal.beta*Vm/g/costitas*(deltaV + Vm/Qm*deltaQ)+Iem * deltax;
% expresion Sotelo he repasado demostracion
      elseif expresionendiffinitas==2,
        deltayelevacion = Qant/g*Vm/Qm*(deltaV+Vnew/Qant*deltaQ); %USBR
      elseif expresionendiffinitas==3      
        deltayelevacion = canal.beta*Qant/g*Vm/Qm*(deltaV+Vnew/Qant*deltaQ)+Iem * deltax; 
%artLC
      endif
      ynext =  (Is*deltax  - deltayelevacion)/costitas + yant;
      error = abs(ynext-ynext0);
      ynext0=ynext;
      
    endwhile
    ndata = ndata + 1;
    x_calc(ndata) = x;
    y_calc(ndata) = ynext;
  endfor
  [x_calc' y_calc']
endif
% detectar singularidades 
indices_validos = find(imag(y_calc)==0);
x_calc = x_calc(indices_validos);
y_calc = y_calc(indices_validos);
elevation = y_calc-Is*x_calc;

x_calc(end)
y_calc(end)

if salida_grafica,
  figure(1)
  hold off;
%subplot(2,1,1)
  plot(x_calc*cos(asin(Is)) , y_calc-Is*x_calc, x_calc*cos(asin(Is)), -Is*x_calc);
  grid on;
  legend('sl','solera');
end

tipocurva='';

if qast.tipo==0,
  if Is>0
    if (yn>yc)&(~isinf(yn)),
      if y0>yn,
        tipocurva='M1';
      elseif y0<yc,
        tipocurva='M3';
      else
        tipocurva='M2';
      endif
    elseif yn<yc,
      if y0<yc,
        tipocurva='S3';
      elseif y0>yc,
        tipocurva='S1';
      else
        tipocurva='S2';
      endif
    elseif isinf(yn)
      if y0<yc,
        tipocurva='H3';
      else
        tipocurva='H2';
      endif
    endif
% H,A
  endif
  


  display(tipocurva)
  sqrt(Fr2(y_calc(end),Q0,canal))
  Is-Ie(y_calc(end),Q0,canal)
  
  if salida_grafica,  
    figure(1)
%subplot(2,1,1)
    if ~isinf(yn),
      plot(x_calc*cos(asin(Is)) , y_calc-Is*x_calc, x_calc*cos(asin(Is)), -Is*x_calc,x_calc*cos(asin(Is)), yc-Is*x_calc*cos(asin(Is)),x_calc*cos(asin(Is)), yn-Is*x_calc*cos(asin(Is)));
      grid on; title(tipocurva)
      legend('sl','solera','yc','yn');
%subplot(2,1,2)
%plot(x_calc , sqrt(Fr2(y_calc,Q0)));grid on
      
      figure(2)
      subplot(3,1,1)
      plot(x_calc , y_calc-Is*x_calc, x_calc, -Is*x_calc, x_calc, yc-Is*x_calc,x_calc, yn-Is*x_calc );
      grid on;legend('sl','solera','yc','yn');
      legend('sl','solera','yc','yn');
    else
      plot(x_calc*cos(asin(Is)) , y_calc-Is*x_calc, x_calc*cos(asin(Is)), -Is*x_calc,x_calc*cos(asin(Is)), yc-Is*x_calc*cos(asin(Is)));
      grid on; title(tipocurva)
      legend('sl','solera','yc');
      figure(2)
      subplot(3,1,1)
      plot(x_calc , y_calc-Is*x_calc, x_calc, -Is*x_calc, x_calc, yc-Is*x_calc );
      grid on;legend('sl','solera','yc');
      legend('sl','solera','yc');
      
    endif
    subplot(3,1,2)
    plot(x_calc , 1-(Fr2(y_calc,Q0,canal)));grid on
    title('1-Fr2 (den)')
    subplot(3,1,3)
    plot(x_calc , Is - Ie(y_calc,Q0,canal));grid on
    title('Is-Ie (num)')
  endif
endif



if salida_ods,
  odswrite(fichero_ods,[x_calc y_calc  y_calc-Is*x_calc],hoja);
endif